//+------------------------------------------------------------------+
//|                                        PointAndFigure mod 02.mq4 |
//|                                 Copyright  2008, jlpiconsulting |
//|                                          jlpiconsulting@yahoo.fr |
//|                                                       mod by nht |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, jlpiconsulting" 
#property link      "jlpiconsulting@yahoo.fr"
//----
#property indicator_separate_window
#property indicator_buffers 1

//---- input parameters 
extern int     UniqueNum = 1234;          // change it if you want to use multiple instances of this indicator
extern string  Separator_1 = "- - - - - - - - - - - - - - - - - - - - - - - - - - - - -";
//----
extern int     BoxCalculationMethod = 2;  // >1< - static, >2< - ADR
extern int     BoxSize = 60;              // >1< ; manual/static 
extern int     BarsToCalculateADR = 100;  // >2< ; number of bars for dynamic box size calculation
extern int     BoxReversal = 3;
extern int     WidthBox = 1;
extern int     MaxBars = 1000;            // restrict indicator to show only given number of bars
extern string  Separator_2 = "- - - - - - - - - - - - - - - - - - - - - - - - - - - - -";
//----
extern bool    DrawAsBoxes = True;        // >True< - Boxes style, >False< - X_O style
//----
extern bool    ShowBoxesOnChart = False;  // draw Boxes on main chart window
//----
extern bool    ShowBoxInfo = True;        // display selected Box calculation info in indicator window
extern string  Separator_3 = "- - - - - - - - - - - - - - - - - - - - - - - - - - - - -";
//----
extern color   UP_Color = MediumBlue;
extern color   DOWN_Color = Red;
extern string  Separator_4 = "- - - - - - - - - - - - - - - - - - - - - - - - - - - - -";
//----
extern bool    ShowPrice = True;
extern bool    PriceAsLine = True;        // >True< - show PRICE as line, >False< - show PRICE as label
extern color   PriceColor = RoyalBlue;
extern string  Separator_5 = "- - - - - - - - - - - - - - - - - - - - - - - - - - - - -";
//----
extern bool    ShowGrid = False;
extern color   GridColor = C'90,90,90';


//----
int      Index = 0;
double   ind_buffer1[];
double   decPoint;

int      Trend;
// int      TrendArray[];
int      BoxCnt = 0, BoxCntUp = 0,  BoxCntDn = 0;
double   MaxOnCahrt = 0, MinOnChart = 0;
double   GridRefPoint = 0;
int      AVGBoxSize, modBoxSize;
double   percentBoxSize;

string   short_name;


//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int init() {
   
   SetIndexStyle(0,DRAW_NONE);
   SetIndexBuffer(0,ind_buffer1);
   
   if ( BoxCalculationMethod == 1 ) 
      short_name = "PointAndFigure (" +BoxSize+ " x " +BoxReversal+ ") Id(.:" +UniqueNum+ ":.)";
   else 
      short_name = "PointAndFigure (dynamic" + " x " +BoxReversal+ ") Id(.:" +UniqueNum+ ":.)";
   
   IndicatorShortName(short_name);

//---- 5to4 and 3to2 digits convertion
   if (Point == 0.00001)
      decPoint = 0.0001;      //5 digits
   else if (Point == 0.001)
      decPoint = 0.01;        //3 digits (JPY pairs)
   else 
      decPoint = Point;       //Normal 
   
   return(0);
}

//+------------------------------------------------------------------+ 
//+------------------------------------------------------------------+ 
int deinit() {

   ClearScreen (UniqueNum, short_name);
   
   Comment("");
   
   return(0);
}

//+------------------------------------------------------------------+ 
//+------------------------------------------------------------------+ 
int start() {
  
   int      i, j, k;
   bool     found = false;
   int      FirstBarIndex;
   int      NbCol;
   double   CurrentBox, BoxPoint;
   int      Size;
   
   AVGBoxSize = MathRound( CalculateAVG(BarsToCalculateADR)/2 );
   
   if ( BoxCalculationMethod == 2 ) {
      modBoxSize = AVGBoxSize;
      BoxPoint = AVGBoxSize*decPoint;  // dynamic Box
   } else {
      modBoxSize = BoxSize;
      BoxPoint = BoxSize*decPoint;     // static Box
   }
   
   FirstBarIndex = IndicatorCounted();
   
   if (MaxBars < Bars)
      FirstBarIndex = MaxBars;
   else
      FirstBarIndex = Bars - 1 ;
   
   if (FirstBarIndex<0) return(-1); //---- check for possible errors
   if (FirstBarIndex>0) FirstBarIndex--; //---- last counted bar will be recounted
   
   NbCol = 0;
   CurrentBox = Open[FirstBarIndex];
   Trend = 0;
   
   
// first pass to count the number of columns
   for(i = FirstBarIndex; i >= 1; i--) {
   
       if (Trend == 0) { // current down
           found = false;
           while(Low[i] <= CurrentBox - BoxPoint) { // search first for next down
               CurrentBox -= BoxPoint;
               found = true;
           }
           if(found) 
               continue;
           if(High[i] >= CurrentBox + BoxReversal*BoxPoint) { // reverse, new column
               NbCol++;
               Trend = 1; // TrendArray[i] = Trend;
               CurrentBox += BoxReversal*BoxPoint;
               while(High[i] >= CurrentBox + BoxPoint) { // search first for next up
                   CurrentBox += BoxPoint;
               }
           }
       }
       if (Trend == 1) { // current up
      
           found = false;
           while(High[i] >= CurrentBox + BoxPoint) { // search first for next up
               CurrentBox += BoxPoint;
               found = true;
           }
           if(found) 
               continue;
           if(Low[i] <= CurrentBox - BoxReversal*BoxPoint) { // reverse, new column
               NbCol++;
               Trend = 0; // TrendArray[i] = Trend;
               CurrentBox -= BoxReversal*BoxPoint;
               while(Low[i] <= CurrentBox - BoxPoint) { // search first for next down
                   CurrentBox -= BoxPoint;
               }
           }
       }
   }
   Size = (NbCol+2)*WidthBox;
   

// second pass for drawing
   if ( !isOldBar() ) 
      ClearScreen (UniqueNum, short_name);

   CurrentBox = Open[FirstBarIndex]; 
   Index = 0;
   for(i = FirstBarIndex; i >= 1; i--) { 
   
       if (Trend == 0) { // current down
           for(k = Size; k > Size - WidthBox; k--)
               ind_buffer1[k] = CurrentBox-BoxPoint;
           
           found = false;
           while(Low[i] <= CurrentBox - BoxPoint) { // search first for next down
               CurrentBox -= BoxPoint;  
               DrawBox(Size,CurrentBox,1,DOWN_Color,i,NbCol);
               GridRefPoint = CurrentBox;
               found = true; 
           } 
           if(found) 
               continue; 
           if(High[i] >= CurrentBox + BoxReversal*BoxPoint) { // reverse, new column
               Size-=WidthBox; 
               Trend = 1; BoxCntDn = 0; BoxCnt = 0 ;
               for (j=0; j<BoxReversal; j++) {
                  CurrentBox += BoxPoint;
                  DrawBox(Size,CurrentBox,1,UP_Color,i,NbCol);
               }
               while(High[i] >= CurrentBox + BoxPoint) { // search first for next up
                   CurrentBox += BoxPoint;  
                   DrawBox(Size,CurrentBox,1,UP_Color,i,NbCol);
               } 
           } // end if high
       } // end if trend 0
       
       if (Trend == 1) { // current up
           for(k = Size; k > Size - WidthBox; k--)
              ind_buffer1[k] = CurrentBox+BoxPoint;
           
           found = false; 
           while(High[i] >= CurrentBox + BoxPoint) { // search first for next up
               CurrentBox += BoxPoint;  
               DrawBox(Size,CurrentBox,1,UP_Color,i,NbCol);
               found = true;  
           } 
           if(found) 
              { continue; }
           if(Low[i] <= CurrentBox - BoxReversal*BoxPoint) { // reverse, new column

               Size-=WidthBox; 
               Trend = 0; BoxCntUp = 0 ; BoxCnt = 0 ;
               for (j=0; j<BoxReversal; j++) {
                  CurrentBox -= BoxPoint;
                  DrawBox(Size,CurrentBox,1,DOWN_Color,i,NbCol);
               } 
               while(Low[i] <= CurrentBox - BoxPoint) { // search first for next down
                   CurrentBox -= BoxPoint;  
                   DrawBox(Size,CurrentBox,1,DOWN_Color,i,NbCol);
               } 
           } // end if low
       } // end if trend 1
   } // end for i
   
   if ( ShowBoxInfo )
      DisplayBoxInfo(AVGBoxSize);
   
   if ( ShowPrice ) 
      ShowCurrentPrice();
   
   if ( ShowGrid ) 
      DrawGrid(GridRefPoint, BoxPoint, NbCol);
   
   return(0); 
}

//+------------------------------------------------------------------+ 
//+------------------------------------------------------------------+ 

void ClearScreen (int tmpID, string tmpWindow_name) {

   int tmpWindow = WindowFind(tmpWindow_name);
   
   for( tmpID = ObjectsTotal()-1; tmpID>-1; tmpID--)
      {
         if (StringFind(ObjectName(tmpID),UniqueNum + " " + tmpWindow + " Box") >= 0)
            ObjectDelete(ObjectName(tmpID));
         if (StringFind(ObjectName(tmpID),UniqueNum + " " + tmpWindow + " BoxFrame") >= 0)
            ObjectDelete(ObjectName(tmpID));
         if (StringFind(ObjectName(tmpID),UniqueNum + " " + tmpWindow + " X") >= 0)
            ObjectDelete(ObjectName(tmpID));
         if (StringFind(ObjectName(tmpID),UniqueNum + " " + tmpWindow + " O") >= 0)
            ObjectDelete(ObjectName(tmpID));
         if (StringFind(ObjectName(tmpID),UniqueNum + " " + tmpWindow + " GridH") >= 0)
            ObjectDelete(ObjectName(tmpID));
         if (StringFind(ObjectName(tmpID),UniqueNum + " " + tmpWindow + " GridV") >= 0)
            ObjectDelete(ObjectName(tmpID));
            
         if (StringFind(ObjectName(tmpID),UniqueNum + " " + 0 + " Box") >= 0)
            ObjectDelete(ObjectName(tmpID));
         if (StringFind(ObjectName(tmpID),UniqueNum + " " + 0 + " BoxFrame") >= 0)
            ObjectDelete(ObjectName(tmpID));
      }
   
   ObjectDelete(UniqueNum+ " " +tmpWindow+ " CurrPrice");
   ObjectDelete(UniqueNum+ " " +tmpWindow+ " BoxInfo");
   ObjectDelete(UniqueNum+ " " +tmpWindow+ " AVGInfo");
   ObjectDelete(UniqueNum+ " " +tmpWindow+ " BoxActive");
}

//+------------------------------------------------------------------+ 
void DrawBox(int xaxis, double yaxis, int direction, color tmpColor, int tmpTime, int tmpNbCol)
{
    int window = WindowFind(short_name);
   
    if(Trend == 1) {  BoxCntUp = BoxCntUp + 1 ;  BoxCnt = BoxCnt + 1 ; }
    if(Trend == 0) {  BoxCntDn = BoxCntDn + 1 ;  BoxCnt = BoxCnt - 1 ; }
   
   if ( !DrawAsBoxes ) {
      Index++;
      if (Trend==1) 
         CreateObject(xaxis, yaxis, " X", window, 1, tmpColor, tmpTime, Index, tmpNbCol);
      else 
         CreateObject(xaxis, yaxis, " O", window, 1, tmpColor, tmpTime, Index, tmpNbCol);
   } else {
      Index++;
      CreateObject(xaxis, yaxis, " Box", window, 1, tmpColor, tmpTime, Index, tmpNbCol);
      CreateObject(xaxis, yaxis, " BoxFrame", window, 1, tmpColor, tmpTime, Index, tmpNbCol);
   } // !DrawAsBoxes
   
   if (ShowBoxesOnChart) {
      Index++;
      
      CreateObject(xaxis, yaxis, " Box", 0, 1, tmpColor, tmpTime, Index, tmpNbCol);
      CreateObject(xaxis, yaxis, " BoxFrame", 0, 1, tmpColor, tmpTime, Index, tmpNbCol);
      
   }
}

//+------------------------------------------------------------------+ 
void CreateObject(int tmpX, double tmpY, string tmpObjectName, int tmpWindow, 
                  int tmpDirection, color tmpColor,int tmpTime, int tmpIdx, int tNbCol)
{
   int FontSize = 10;
   string BoxInfo = StringConcatenate(UniqueNum," ",tmpWindow," BoxInfo");
   string AVGInfo = StringConcatenate(UniqueNum," ",tmpWindow," AVGInfo");
   string slectedSig = StringConcatenate(UniqueNum," ",tmpWindow," BoxActive");
   string selBox = StringConcatenate( "BoxSize - ", DoubleToStr(BoxSize, 0) );
   string selAVG = StringConcatenate( "AVG(",BarsToCalculateADR,")/2 BoxSize - ", DoubleToStr(AVGBoxSize, 0) );
   string slected = CharToStr(231);
   
   string tObjectName = UniqueNum +" " + tmpWindow + tmpObjectName;
   string tIdx = " " + tmpIdx;
   string tName = StringConcatenate(tObjectName, tIdx);
   
   
   if (ObjectFind(tmpObjectName) == -1) {
      
      if (tmpObjectName == " X") {
         for (int j=1;j<=2;j++) {
               ObjectDelete(" X"+ j + Index);
            }
         ObjectCreate(StringConcatenate(tObjectName, "1", tIdx), OBJ_TREND, tmpWindow, 
                  Time[tmpX+WidthBox+2*WidthBox],tmpY, 
                  Time[tmpX-WidthBox+WidthBox+2*WidthBox],tmpY+tmpDirection*modBoxSize*decPoint);
         ObjectCreate(StringConcatenate(tObjectName, "2", tIdx), OBJ_TREND, tmpWindow, 
                  Time[tmpX+WidthBox+2*WidthBox],tmpY+tmpDirection*modBoxSize*decPoint, 
                  Time[tmpX-WidthBox+WidthBox+2*WidthBox],tmpY);
         for (int k=1;k<=2;k++) {
            ObjectSet(StringConcatenate(tObjectName, k, tIdx),OBJPROP_RAY,false);
            ObjectSet(StringConcatenate(tObjectName, k, tIdx),OBJPROP_COLOR,tmpColor);
         }
         
      } else if (tmpObjectName == " O") {
         ObjectDelete(tName);
         if ( StringFind(Symbol(),"JPY",0) < 0 ) {
            ObjectCreate(tName, OBJ_ELLIPSE, tmpWindow, 
                  Time[tmpX+WidthBox+2*WidthBox],tmpY+tmpDirection*modBoxSize*decPoint/2, 
                  Time[tmpX-WidthBox+WidthBox+2*WidthBox],tmpY+tmpDirection*modBoxSize*decPoint/2);
            ObjectSet(tName,OBJPROP_COLOR,tmpColor);
            ObjectSet(tName,OBJPROP_BACK ,False);
            ObjectSet(tName,OBJPROP_SCALE, ((1.0/modBoxSize)*0.0001/decPoint*WidthBox) );
         } else {
//
//----   error with scaling JPY pairs; instead of ELLIPSE have to use TRIANGLE object
//
            ObjectCreate(tName, OBJ_TRIANGLE, tmpWindow, 
                  Time[tmpX+WidthBox+2*WidthBox],tmpY+tmpDirection*modBoxSize*decPoint, 
                  Time[tmpX-WidthBox+WidthBox+2*WidthBox],tmpY,
                  Time[tmpX-WidthBox+WidthBox+2*WidthBox],tmpY+tmpDirection*modBoxSize*decPoint);
            ObjectSet(tName,OBJPROP_COLOR,tmpColor);
            ObjectSet(tName,OBJPROP_BACK ,False);
         }
         
      } else if (tmpObjectName == " Box") {
         ObjectCreate(tName, OBJ_RECTANGLE, tmpWindow, 0, 0, 0, 0);
         ObjectSet(tName, OBJPROP_TIME1, Time[tmpX + 2*WidthBox]);
         ObjectSet(tName, OBJPROP_PRICE1, tmpY );
         ObjectSet(tName, OBJPROP_TIME2, Time[tmpX - WidthBox + 2*WidthBox]);
         ObjectSet(tName, OBJPROP_PRICE2, tmpY + tmpDirection*modBoxSize*decPoint);
         ObjectSet(tName, OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet(tName, OBJPROP_BACK, True);
         ObjectSet(tName, OBJPROP_COLOR, tmpColor);
         
      } else if (tmpObjectName == " BoxFrame") {
         ObjectCreate(tName, OBJ_RECTANGLE, tmpWindow, 0, 0, 0, 0);
         ObjectSet(tName, OBJPROP_TIME1, Time[tmpX + 2*WidthBox]);
         ObjectSet(tName, OBJPROP_PRICE1, tmpY);
         ObjectSet(tName, OBJPROP_TIME2, Time[tmpX - WidthBox + 2*WidthBox]);
         ObjectSet(tName, OBJPROP_PRICE2, tmpY + tmpDirection*modBoxSize*decPoint);
         ObjectSet(tName, OBJPROP_STYLE, STYLE_SOLID);
         ObjectSet(tName, OBJPROP_BACK, False);
         ObjectSet(tName, OBJPROP_COLOR, White);
         
      } else if (tmpObjectName == " GridH") {
         ObjectDelete(tName);
         ObjectCreate(tName, OBJ_GANNLINE, tmpWindow, 
               tmpTime, tmpY + tmpDirection*modBoxSize*decPoint, Time[0], tmpY + tmpDirection*modBoxSize*decPoint);
         ObjectSet(tName, OBJPROP_COLOR, tmpColor);
         ObjectSet(tName, OBJPROP_BACK, true);
         
      } else if (tmpObjectName == " GridV") {
         ObjectDelete(tName);
         ObjectCreate(tName, OBJ_VLINE, tmpWindow, Time[tmpX], 0);
         ObjectSet(tName, OBJPROP_COLOR, tmpColor);
         ObjectSet(tName, OBJPROP_BACK, true);
         
      } else if (tmpObjectName == " BoxInfo") {
         ObjectDelete(BoxInfo);
         ObjectCreate(BoxInfo,OBJ_LABEL,tmpWindow,0,0,0,0);
         ObjectSet(BoxInfo,OBJPROP_CORNER,1);
         ObjectSet(BoxInfo,OBJPROP_XDISTANCE,tmpX + 2*FontSize);
         ObjectSet(BoxInfo,OBJPROP_YDISTANCE,tmpY + FontSize);
         ObjectSetText(BoxInfo,selBox,FontSize,"Arial",tmpColor);
         
      } else if (tmpObjectName == " AVGInfo") {
         ObjectDelete(AVGInfo);
         ObjectCreate(AVGInfo,OBJ_LABEL,tmpWindow,0,0,0,0);
         ObjectSet(AVGInfo,OBJPROP_CORNER,1);
         ObjectSet(AVGInfo,OBJPROP_XDISTANCE,tmpX + 2*FontSize);
         ObjectSet(AVGInfo,OBJPROP_YDISTANCE,tmpY + 2*FontSize + 5);
         ObjectSetText(AVGInfo,selAVG,FontSize,"Arial",tmpColor);
         
      } else if (tmpObjectName == " BoxActive") {
         
         if ( BoxCalculationMethod == 1 )
            tmpY = tmpY + FontSize;
         else 
            tmpY = tmpY + 2*FontSize + 5;
            
         ObjectDelete(slectedSig);
         ObjectCreate(slectedSig,OBJ_LABEL,tmpWindow,0,0,0,0);
         ObjectSet(slectedSig,OBJPROP_CORNER,1);
         ObjectSet(slectedSig,OBJPROP_XDISTANCE,0 + 1.5*FontSize);
         ObjectSet(slectedSig,OBJPROP_YDISTANCE,tmpY);
         ObjectSetText(slectedSig,slected,FontSize,"Wingdings",tmpColor);
         
      } else 
         return(0);
   }
}

//+------------------------------------------------------------------+ 
bool isOldBar()
{
   static int time;
   bool retVal;
   
   if (time == Time[0]) {
      retVal = true;
   } else {
      time = Time[0];
      retVal = false;
   }

   return(retVal);
}

//+------------------------------------------------------------------+ 
double CalculateAVG(int BarsToCount)
{
   int   tempSum = 0;
   int   v;
   
   if (BarsToCount<=0) BarsToCount=1;
   
   for (v=1; v<=BarsToCount; v++)
      tempSum = tempSum + getRange(v);
   
   tempSum = tempSum/BarsToCount;

   return (NormalizeDouble(tempSum,0));
}

//+------------------------------------------------------------------+ 
double getRange(int barIdx)
{
   double   range;

      range = High[barIdx] - Low[barIdx];
      return (NormalizeDouble(range/decPoint,0));
}

//+------------------------------------------------------------------+ 
void DisplayBoxInfo(int AVGBoxSize)
{
   int DisplayStarts_X = 10, DisplayStarts_Y = 10;
   
   int tmpWindow =  WindowFind(short_name);
   
   CreateObject(DisplayStarts_X, DisplayStarts_Y, " BoxInfo", tmpWindow, 1, Yellow, 0, 0, 0);
   CreateObject(DisplayStarts_X, DisplayStarts_Y, " AVGInfo", tmpWindow, 1, Yellow, 0, 0, 0);
   CreateObject(DisplayStarts_X, DisplayStarts_Y, " BoxActive", tmpWindow, 1, Red, 0, 0, 0);
}

//+------------------------------------------------------------------+ 
void ShowCurrentPrice()
{
    int window = WindowFind(short_name);
    
    if (!PriceAsLine) {
      ObjectDelete(UniqueNum+ " " +window+ " CurrPrice");
      ObjectCreate(UniqueNum+ " " +window+ " CurrPrice", OBJ_ARROW, window, Time[0],Close[0]);
      ObjectSet(UniqueNum+ " " +window+ " CurrPrice", OBJPROP_COLOR, PriceColor);
      ObjectSet(UniqueNum+ " " +window+ " CurrPrice", OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
   } else {
      ObjectDelete(UniqueNum+ " " +window+ " CurrPrice");
      ObjectCreate(UniqueNum+ " " +window+ " CurrPrice", OBJ_HLINE, window, 0, Close[0]);
      ObjectSet(UniqueNum+ " " +window+ " CurrPrice", OBJPROP_COLOR, PriceColor);
      ObjectSet(UniqueNum+ " " +window+ " CurrPrice", OBJPROP_WIDTH, 1);
      ObjectSet(UniqueNum+ " " +window+ " CurrPrice", OBJPROP_STYLE, STYLE_DOT);
   }
}

//+------------------------------------------------------------------+ 
void DrawGrid(double tmpGridRefPoint, double tmpBoxPoint, int tmpNbCol)
{
      MaxOnCahrt = iHigh(NULL,0,iHighest(NULL,0,MODE_HIGH,Bars,0));
      MinOnChart = iLow(NULL,0,iLowest(NULL,0,MODE_LOW,Bars,0));
      
      if ( tmpGridRefPoint>MinOnChart ) {
         int GridStartPoint = MathRound( (tmpGridRefPoint-MinOnChart)/tmpBoxPoint ) + 1;
         tmpGridRefPoint = GridRefPoint - GridStartPoint*tmpBoxPoint;
      }
      
      int NbRow = MathCeil( (MaxOnCahrt-MinOnChart) / tmpBoxPoint );
      
      for(int l = NbRow+10; l >= 1; l--) 
         CreateObject(0, tmpGridRefPoint + (l-5)*tmpBoxPoint, " GridH", 
                     WindowFind(short_name), 1, GridColor, Time[iBars(NULL,0)-20], l, 0);
      
      for(int m = tmpNbCol+10; m >= 0; m--) 
         CreateObject(iBarShift( NULL,0,iTime(NULL,0,m*WidthBox)), 0, " GridV", 
                     WindowFind(short_name), 1, GridColor, 0, m, 0);
}

//+------------------------------------------------------------------+ 
//+------------------------------------------------------------------+ 


